<?php
/*
** anti_offline_browser.php - simple php scipt against offline browsers
** Copyright (C) 2004 Stefan Bauckmeier <stefan@bauckmeier.de>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
*/
// config
$antigrabber_iplistdir		= '/path/to/iplists';			// path to directory with the searchengine-ip-lists
$antigrabber_useragentblacklist	= '/path/to/useragentblacklist.txt';	// path to user agent blacklist
$antigrabber_errorurl		= '/fehler.html';			// url for redirection on detecting offline browser
$antigrabber_max_site_rate	= 6;					// max pages per 10 seconds
$antigrabber_debug		= true;
// config end

// check if session is allready startet
if ( !session_id() ) {
	session_start();
}

// store session variables and validate user agent string when the user entered the page
if ( !isset($_SESSION['antigrabber_starttime']) ) {
	// set session vars to a start value
	$_SESSION['antigrabber_starttime'] = time();
	$_SESSION['antigrabber_userisgrabber'] = false;
	$_SESSION['antigrabber_issearchengine'] = false;
	$_SESSION['antigrabber_count'] = 0;
	
	// check useragent
	$antigrabber_useragent = strtolower($_SERVER['HTTP_USER_AGENT']);
	$antigrabber_uablfile = @fopen($antigrabber_useragentblacklist, 'r');
	if($antigrabber_uablfile) {
		while(!feof($antigrabber_uablfile) && $_SESSION['antigrabber_userisgrabber'] == false) {
			$antigrabber_uablfileline = trim(fgets($antigrabber_uablfile));
			if ( strlen($antigrabber_uablfileline) > 1 && substr($antigrabber_uablfileline,0,1) != '#' ) {
				if ( strstr($antigrabber_useragent, strtolower($antigrabber_uablfileline) ) ) {
					$_SESSION['antigrabber_userisgrabber'] = true;
				}
			}
		}
		fclose($antigrabber_uablfile);
	} else {
		if ( $antigrabber_debug == true ) {
			echo "error: can't open user agent blacklist ($antigrabber_useragentblacklist) for reading";
		}
	}
}

// if user was allready detected as offline browser -> diplay error page
if ( 
	$_SESSION['antigrabber_userisgrabber'] == true
) {
	header('Location: '.$antigrabber_errorurl);
	die("go to <a href=\"$antigrabber_errorurl\">$antigrabber_errorurl</a> and read why u are banned");
}

// count hits of this user
$_SESSION['antigrabber_count']++;

// detect offline explorer calculating page hits per 10seconds
if ( $_SESSION['antigrabber_issearchengine'] != true ) {
	if ( $_SESSION['antigrabber_count'] > 1 && (time() - $_SESSION['antigrabber_starttime']) > 1 ) {
		
		$antigrabber_time = @round((time() - $_SESSION['antigrabber_starttime']) / 10);
		if ( $antigrabber_time < 1 ) { $antigrabber_time = 1; }
		
		if ( ($_SESSION['antigrabber_count'] / $antigrabber_time) > $antigrabber_max_site_rate ) {

			// check if ip is in searchengine-ip-list
			$antigrabber_ipdir = dir($antigrabber_iplistdir);
			while (false !== ($antigrabber_ipdirentry = $antigrabber_ipdir->read()) && $_SESSION['antigrabber_issearchengine'] != true) {
				if ( is_file($antigrabber_iplistdir.'/'.$antigrabber_ipdirentry) && substr($antigrabber_ipdirentry,0,1) != '.' ) {
					$antigrabber_ipfile = @fopen($antigrabber_iplistdir.'/'.$antigrabber_ipdirentry, 'r');
					if($antigrabber_ipfile) {
						while(!feof($antigrabber_ipfile) && $_SESSION['antigrabber_issearchengine'] != true) {
							$antigrabber_ipfileline = trim(fgets($antigrabber_ipfile));
							if ( strlen($antigrabber_ipfileline) > 1 && substr($antigrabber_ipfileline,0,1) != '#' ) {
								if ( $_SERVER['REMOTE_ADDR'] == $antigrabber_ipfileline ) {
									$_SESSION['antigrabber_issearchengine'] = true;
								}
							}
						}
						fclose($antigrabber_ipfile);
					}
				} else {
					if ( $antigrabber_debug == true && substr($antigrabber_ipdirentry,0,1) != '.' ) {
						echo "error: can't open ip whitelist file ($antigrabber_iplistdir/$antigrabber_ipdirentry) for reading";
					}
				}
			}
			
			if ( $_SESSION['antigrabber_issearchengine'] != true ) {
				$_SESSION['antigrabber_userisgrabber'] = true;
				header('Location: '.$antigrabber_errorurl);
				die("go to <a href=\"$antigrabber_errorurl\">$antigrabber_errorurl</a> and read why u are banned");
			}
		}
	}
}
?>